/*
 * 篆字部首検索システム（テキスト検索版）
 */
!function(){"use strict";var ids_analysis_data=[];if("undefined"!=typeof ids_analysis_data_lz&&ids_analysis_data_lz){var ids_analysis_data_json=JSON.parse(LZString.decompressFromBase64(ids_analysis_data_lz));ids_analysis_data_json&&ids_analysis_data_json.data?(ids_analysis_data=ids_analysis_data_json.data,function(){for(var ids_dict={},ids_breakdown_dict={},vnt_dict={},vntr_dict={},dict_index={},i=0;i<ids_analysis_data.length;i++){var list,list_index,data=ids_analysis_data[i],char=data.char,ids=data.ids,head_char=0<ids.length?ids[0]:"",char2=1<ids.length?ids.substr(1):"";if("→"===head_char?(list=vnt_dict[char]||[],-1===$.inArray(char2,list)&&(list.push(char2),vnt_dict[char]=list),list=vntr_dict[char2]||[],-1===$.inArray(char,list)&&(list.push(char),vntr_dict[char2]=list)):"←"===head_char?(list=vnt_dict[char2]||[],-1===$.inArray(char,list)&&(list.push(char),vnt_dict[char2]=list)):ids_dict[char]=ids,"bd"in data&&data.bd){var breakdown=data.bd;"kxr"in data&&data.kxr&&(breakdown+=" "+data.kxr),ids_breakdown_dict[char]=breakdown}(list_index=dict_index[char]||[]).push(i),dict_index[char]=list_index}
function lookupChar(char){
var result=[];
!function analyze(lookup_char,result_list,done_list){
result_list=result_list||[],(done_list=done_list||[]).push(lookup_char);
var char,i,ids=ids_dict[lookup_char]||"",vnt_list=vnt_dict[lookup_char]||[],vntr_list=vntr_dict[lookup_char]||[],result={char:lookup_char,ids:ids};

for(result_list.push(result),i=0;i<vnt_list.length;i++)char=vnt_list[i],-1===$.inArray(char,done_list)&&(done_list.push(char),analyze(char,result_list,done_list));
for(i=0;i<vntr_list.length;i++)char=vntr_list[i],-1===$.inArray(char,done_list)&&(done_list.push(char),analyze(char,result_list,done_list))}(char,result);
for(var ids_analysis_data_result=[],done_list=[],i=0;i<result.length;i++)
for(var indices=dict_index[result[i].char]||[],j=0;j<indices.length;j++){
var index=indices[j];
-1===$.inArray(index,done_list)&&(done_list.push(index),ids_analysis_data_result.push(ids_analysis_data[index]))
}
return ids_analysis_data_result}
function hideTables(){
$(".bootgrid-table").hide(),$(".bootgrid-footer").hide()}
var formatters={ndl_link:function(column,row){if(row[column.id]){for(var links=[],elems=row[column.id].split("\t"),i=0;i<elems.length;i++){var url="https://dl.ndl.go.jp/info:ndljp/pid/"+elems[i];links.push('<a class="btn btn-xs btn-default" href="'+url+'" target="_blank"><span class="glyphicon glyphicon-new-window"></span></a>')}return links.join(" ")}},seal_link:function(column,row){return'<form name="CsvSearch" method="POST" action="https://base1.nijl.ac.jp/infolib/meta_pub/sresult" target="_blank"><input name="DEF_XSL" value="default" type="hidden"><input name="SUM_KIND" value="CsvSummary" type="hidden"><input name="SUM_NUMBER" value="50" type="hidden"><input name="IS_NUMBER" value="50" type="hidden"><input name="META_KIND" value="NOFRAME" type="hidden"><input name="IS_DB" value="G0038791ZSI" type="hidden"><input name="IS_KIND" value="CsvInitSearch" type="hidden"><input name="IS_SCH" value="CSV" type="hidden"><input name="IS_STYLE" value="default" type="hidden"><input name="IS_TYPE" value="csv" type="hidden"><input name="DB_ID" value="G0038791ZSI" type="hidden"><input name="GRP_ID" value="G0038791" type="hidden"><input name="IS_START" value="1" type="hidden"><input name="IS_EXTSCH" value="" type="hidden"><input name="XPARA" value="" type="hidden"><input name="IS_DETAILTYPE" value="" type="hidden"><input name="IMAGE_XML_TYPE" value="" type="hidden"><input name="IMAGE_VIEW_DIRECTION" value="" type="hidden"><input name="IS_TAG_S1" value="Record" type="hidden"><input name="IS_REG_S1" value="" type="hidden"><input name="SUM_TYPE" value="normal" type="hidden"><input name="IS_KEY_S1" value="" type="hidden"><input name="IS_LGC_S2" value="AND" type="hidden"><input name="IS_TAG_S2" value="GroupSearch1" type="hidden"><input name="IS_KEY_S2" value="'+row.char+'" type="hidden"><input name="IS_LGC_S15" value="AND" type="hidden"><input name="IS_TAG_S15" value="Cul25" type="hidden"><input name="IS_KEY_S15" value="" type="hidden"><button type="submit" class="btn btn-xs btn-default" title="蔵書印DBで「'+row.char+'」の用例を検索"><span class="glyphicon glyphicon-new-window"></span></button></form>'}};$("#grid-cluster").bootgrid({rowCount:[-1],columnSelection:!1,navigation:0,formatters:formatters}),$("#grid-ids").bootgrid({rowCount:[100],columnSelection:!1,navigation:2,formatters:formatters}).bootgrid("append",ids_analysis_data),$("#grid-ids-bd").bootgrid({rowCount:[100],columnSelection:!1,navigation:2,formatters:formatters}),hideTables(),$("#grids").show();var timer=null;


$("body").on("click", ".booktab", function(){
  var bn = $(this).attr('data-bn');
  $(".ebimgs").hide();
  $(".booktab").each(function(){
    $(this).css({'background-color':'linen'});
  });
  $(this).css({'background-color':'wheat'});
  if(bn == 'all'){
    $(".ebimgs").show();
  }
  else{
    $(".ebimgs[data-book='"+bn+"']").show();
  }
});

$("#input-char").on("keyup",function input_char_keyup(e){
var str,cjkCompatData,reg,char=$.trim($(this).val());
if((char=String.prototype.normalize?char.normalize("NFC"):(str=char,cjkCompatData={"豈":"豈","更":"更","車":"車","賈":"賈","滑":"滑","串":"串","句":"句","龜":"龜","龜":"龜","契":"契","金":"金","喇":"喇","奈":"奈","懶":"懶","癩":"癩","羅":"羅","蘿":"蘿","螺":"螺","裸":"裸","邏":"邏","樂":"樂","洛":"洛","烙":"烙","珞":"珞","落":"落","酪":"酪","駱":"駱","亂":"亂","卵":"卵","欄":"欄","爛":"爛","蘭":"蘭","鸞":"鸞","嵐":"嵐","濫":"濫","藍":"藍","襤":"襤","拉":"拉","臘":"臘","蠟":"蠟","廊":"廊","朗":"朗","浪":"浪","狼":"狼","郎":"郎","來":"來","冷":"冷","勞":"勞","擄":"擄","櫓":"櫓","爐":"爐","盧":"盧","老":"老","蘆":"蘆","虜":"虜","路":"路","露":"露","魯":"魯","鷺":"鷺","碌":"碌","祿":"祿","綠":"綠","菉":"菉","錄":"錄","鹿":"鹿","論":"論","壟":"壟","弄":"弄","籠":"籠","聾":"聾","牢":"牢","磊":"磊","賂":"賂","雷":"雷","壘":"壘","屢":"屢","樓":"樓","淚":"淚","漏":"漏","累":"累","縷":"縷","陋":"陋","勒":"勒","肋":"肋","凜":"凜","凌":"凌","稜":"稜","綾":"綾","菱":"菱","陵":"陵","讀":"讀","拏":"拏","樂":"樂","諾":"諾","丹":"丹","寧":"寧","怒":"怒","率":"率","異":"異","北":"北","磻":"磻","便":"便","復":"復","不":"不","泌":"泌","數":"數","索":"索","參":"參","塞":"塞","省":"省","葉":"葉","說":"說","殺":"殺","辰":"辰","沈":"沈","拾":"拾","若":"若","掠":"掠","略":"略","亮":"亮","兩":"兩","凉":"凉","梁":"梁","糧":"糧","良":"良","諒":"諒","量":"量","勵":"勵","呂":"呂","女":"女","廬":"廬","旅":"旅","濾":"濾","礪":"礪","閭":"閭","驪":"驪","麗":"麗","黎":"黎","力":"力","曆":"曆","歷":"歷","轢":"轢","年":"年","憐":"憐","戀":"戀","撚":"撚","漣":"漣","煉":"煉","璉":"璉","秊":"秊","練":"練","聯":"聯","輦":"輦","蓮":"蓮","連":"連","鍊":"鍊","列":"列","劣":"劣","咽":"咽","烈":"烈","裂":"裂","說":"說","廉":"廉","念":"念","捻":"捻","殮":"殮","簾":"簾","獵":"獵","令":"令","囹":"囹","寧":"寧","嶺":"嶺","怜":"怜","玲":"玲","瑩":"瑩","羚":"羚","聆":"聆","鈴":"鈴","零":"零","靈":"靈","領":"領","例":"例","禮":"禮","醴":"醴","隸":"隸","惡":"惡","了":"了","僚":"僚","寮":"寮","尿":"尿","料":"料","樂":"樂","燎":"燎","療":"療","蓼":"蓼","遼":"遼","龍":"龍","暈":"暈","阮":"阮","劉":"劉","杻":"杻","柳":"柳","流":"流","溜":"溜","琉":"琉","留":"留","硫":"硫","紐":"紐","類":"類","六":"六","戮":"戮","陸":"陸","倫":"倫","崙":"崙","淪":"淪","輪":"輪","律":"律","慄":"慄","栗":"栗","率":"率","隆":"隆","利":"利","吏":"吏","履":"履","易":"易","李":"李","梨":"梨","泥":"泥","理":"理","痢":"痢","罹":"罹","裏":"裏","裡":"裡","里":"里","離":"離","匿":"匿","溺":"溺","吝":"吝","燐":"燐","璘":"璘","藺":"藺","隣":"隣","鱗":"鱗","麟":"麟","林":"林","淋":"淋","臨":"臨","立":"立","笠":"笠","粒":"粒","狀":"狀","炙":"炙","識":"識","什":"什","茶":"茶","刺":"刺","切":"切","度":"度","拓":"拓","糖":"糖","宅":"宅","洞":"洞","暴":"暴","輻":"輻","行":"行","降":"降","見":"見","廓":"廓","兀":"兀","嗀":"嗀","塚":"塚","晴":"晴","凞":"凞","猪":"猪","益":"益","礼":"礼","神":"神","祥":"祥","福":"福","靖":"靖","精":"精","羽":"羽","蘒":"蘒","諸":"諸","逸":"逸","都":"都","飯":"飯","飼":"飼","館":"館","鶴":"鶴","郞":"郞","隷":"隷","侮":"侮","僧":"僧","免":"免","勉":"勉","勤":"勤","卑":"卑","喝":"喝","嘆":"嘆","器":"器","塀":"塀","墨":"墨","層":"層","屮":"屮","悔":"悔","慨":"慨","憎":"憎","懲":"懲","敏":"敏","既":"既","暑":"暑","梅":"梅","海":"海","渚":"渚","漢":"漢","煮":"煮","爫":"爫","琢":"琢","碑":"碑","社":"社","祉":"祉","祈":"祈","祐":"祐","祖":"祖","祝":"祝","禍":"禍","禎":"禎","穀":"穀","突":"突","節":"節","練":"練","縉":"縉","繁":"繁","署":"署","者":"者","臭":"臭","艹":"艹","艹":"艹","著":"著","褐":"褐","視":"視","謁":"謁","謹":"謹","賓":"賓","贈":"贈","辶":"辶","逸":"逸","難":"難","響":"響","頻":"頻","恵":"恵","𤋮":"𤋮","舘":"舘","並":"並","况":"况","全":"全","侀":"侀","充":"充","冀":"冀","勇":"勇","勺":"勺","喝":"喝","啕":"啕","喙":"喙","嗢":"嗢","塚":"塚","墳":"墳","奄":"奄","奔":"奔","婢":"婢","嬨":"嬨","廒":"廒","廙":"廙","彩":"彩","徭":"徭","惘":"惘","慎":"慎","愈":"愈","憎":"憎","慠":"慠","懲":"懲","戴":"戴","揄":"揄","搜":"搜","摒":"摒","敖":"敖","晴":"晴","朗":"朗","望":"望","杖":"杖","歹":"歹","殺":"殺","流":"流","滛":"滛","滋":"滋","漢":"漢","瀞":"瀞","煮":"煮","瞧":"瞧","爵":"爵","犯":"犯","猪":"猪","瑱":"瑱","甆":"甆","画":"画","瘝":"瘝","瘟":"瘟","益":"益","盛":"盛","直":"直","睊":"睊","着":"着","磌":"磌","窱":"窱","節":"節","类":"类","絛":"絛","練":"練","缾":"缾","者":"者","荒":"荒","華":"華","蝹":"蝹","襁":"襁","覆":"覆","視":"視","調":"調","諸":"諸","請":"請","謁":"謁","諾":"諾","諭":"諭","謹":"謹","變":"變","贈":"贈","輸":"輸","遲":"遲","醙":"醙","鉶":"鉶","陼":"陼","難":"難","靖":"靖","韛":"韛","響":"響","頋":"頋","頻":"頻","鬒":"鬒","龜":"龜","𢡊":"𢡊","𢡄":"𢡄","𣏕":"𣏕","㮝":"㮝","䀘":"䀘","䀹":"䀹","𥉉":"𥉉","𥳐":"𥳐","𧻓":"𧻓","齃":"齃","龎":"龎"},reg=new RegExp("["+Object.keys(cjkCompatData).join("")+"]","g"),str.replace(reg,function(match){return cjkCompatData[match]})))!==input_char_keyup.lastChar&&(0<char.length||13===e.which?(clearTimeout(timer),timer=setTimeout(function(){hideTables();var args=char.split(/[ \u3000]/);
if(args.length<2){
var ids_analysis_data_result=lookupChar(char);
var addimages = {};
var addimagestemp = [];
var hist = [];
var eachbook = {};
var eachbooktag = '';
var eachbooknamedict = {};
var eachtagdict = {};
for(var n=0;n<ids_analysis_data_result.length;n++){
   var achar = ids_analysis_data_result[n]['char']  
       console.log(achar);
   var unicode = "U+"+achar.codePointAt(0).toString(16).toUpperCase();
   var chartags = '';
     if(hist.indexOf(unicode)){ 
     if (chardata[unicode]){
       var ochar = achar;
       chardata[unicode].forEach(function(e){
         var ardirs = e.split('_');
         if(ardirs[3].length < 5){
	   var xardirs = ardirs[3].replace(/X/, '');
	   ardirs[3] = 'X'+xardirs.padStart(4, '0');
         }	   
         if(ardirs[4].length < 5){
	   var yardirs = ardirs[4].replace(/Y/, '');
	   ardirs[4] = 'Y'+yardirs.padStart(4, '0');
         }	   
         var ardirsall = ardirs[0]+'_'+ardirs[1]+'_'+ardirs[2]+'_'+ardirs[3]+'_'+ardirs[4];
         var imgfname = unicode+'_TE000'+ardirsall+'.jpg';
       
         var dir = 'https://mp.ex.nii.ac.jp/tensho/book/TE000'+ardirs[0]+'/characters/'+unicode+'/'+imgfname;
         var dirkey = ardirs[0]+'_'+unicode+'_'+imgfname;
	   //console.log(imgfname);
         if (eachbook['TE000'+ardirs[0]] == undefined){
           eachbook['TE000'+ardirs[0]] = '';
         } 
         //eachbook['TE000'+ardirs[0]] += '<img class="charimg2" src="'+dir+'" data-toggle="tooltip" data-placement="left" height="50px"> ';
         if (eachtagdict['TE000'+ardirs[0]] == undefined){
           eachtagdict['TE000'+ardirs[0]] = {}
         } 
         if (eachtagdict['TE000'+ardirs[0]][dirkey] == undefined){
           eachtagdict['TE000'+ardirs[0]][dirkey] = '';
         } 
         eachtagdict['TE000'+ardirs[0]][dirkey] = '<img class="charimg2" src="'+dir+'" data-toggle="tooltip" data-placement="left" height="50px"> ';

       //var bookname = bookdata['TE000'+ardirs[0]];
       //chartags += 
       });
	//addimages[achar] = chartags;
//	addimages[achar] = eachbookname+eachbooktag;
	hist.push(unicode);
     }
     }
}

var bkorder = ['TE00015','TE00016','TE00017','TE00018','TE00019','TE00020','TE00021', 'TE00001', 'TE00002', 'TE00005', 'TE00004', 'TE00006', 'TE00003'];

for (var eb of bkorder){
  if(eachbook[eb] != undefined){
	 var bookname = bookdata[eb];
         var ebimglen = Object.keys(eachtagdict[eb]).length;
          eachbooknamedict[eb] = '<span class="booktab" data-bn="'+eb+'"><span style="font-weight:bold">'+bookname+'</span>('+ebimglen+')</span>';
  }
}
console.log(bkorder);
//var eachtag = '<table style="table-layout:fixed;width:100%">';
var eachtag = '<div>';
var eachbookname = '<div style="margin-bottom:5px" class="ebnames">';
for (var ebn of bkorder){
  if(eachbooknamedict[ebn] != undefined){
    eachbookname += eachbooknamedict[ebn];
//    eachtag += '<tr class="ebimgs" data-book="'+ebn+'"><td style="width:120px">'+bookdata[ebn]+'</td><td style="overflow-x:auto">';
    eachtag += '<div class="ebimgs" data-book="'+ebn+'" style="overflow-x:auto"><div>'+bookdata[ebn]+'</div>';
    for (var keydir in eachtagdict[ebn]){
      eachtag += eachtagdict[ebn][keydir];
    }
//    eachtag += '</td></tr>';
    eachtag += '</div>';
  }
}
//eachtag += '</table>';
eachtag += '</div>';
eachbookname += '<span class="booktab" data-bn="all">すべて</span></div>';

$.when(
$("#grid-cluster").bootgrid("clear").bootgrid("append",ids_analysis_data_result),$("#grid-ids").bootgrid("search",char),$("#grid-cluster").show(),$("#grid-ids").show(),$("#grid-ids-footer").show()
).done(function(){
var keys = Object.keys(addimages);
keys.sort();
$(".addimgs2").remove();
//for (var key of keys){
// console.log(addimages[key]);
// $("#grid-cluster tbody").after('<tr><td colspan="8" class="addimgs2">'+key+': '+addimages[key]+'</td></tr>');
 $(".addimgs2").remove();
 $("#grid-cluster tbody").after('<tr><td colspan="8" class="addimgs2">'+eachbookname+eachtag+'</td></tr>');
 //  $("#grid-cluster  tbody tr:first").after('<tr><td colspan="8">'+addimagestemp[0]+'</td></tr>');
//}
$(".ebimgs").hide();
$(".ebimgs").eq(0).show();

});
// console.log('h'+$("#grid-cluster > tbody").html());

}else{var ids_breakdown_lookup_result=function(args){var result=[];try{for(var reg="^",i=0;i<args.length;i++)reg+="(?=.*"+args[i]+")";var char,re=new RegExp(reg),keys=Object.keys(ids_breakdown_dict);for(i=0;i<keys.length;i++)if(char=keys[i],re.test(ids_breakdown_dict[char]))for(var indices=dict_index[char]||[],j=0;j<indices.length;j++){
var index=indices[j];
result.push(ids_analysis_data[index])
}
}
catch(e){}
return result
}(args);
$("#grid-ids-bd").bootgrid("clear").bootgrid("append",ids_breakdown_lookup_result),$("#grid-ids-bd").show(),$("#grid-ids-bd-footer").show()
}},250)):hideTables()),history.replaceState&&void 0!==history.state&&char!==input_char_keyup.lastChar){var newUrl=location.protocol+"//"+location.host+location.pathname,params_=[];0<char.length&&params_.push("char="+char),0<params_.length&&(newUrl+="?"+params_.join("&")),history.replaceState(null,null,newUrl)}input_char_keyup.lastChar=char});var match=location.search.match(/(?:&|\?)char=(.*?)(?:&|$)/);if(match){var char_param=decodeURIComponent(match[1]);""!==char_param&&$("#input-char").val(char_param).trigger("keyup")}$("#search-icon").on("click",function(){$("#input-char").trigger("keyup")})}()):$("#msg").text("データ異常").show()}else $("#msg").text("データ取得失敗").show()}();
