#!/usr/bin/env python3
import csv
for n in range(15,22):
  sn = str(n)
  fn = 'TE000'+sn+'_coordinate.csv'
  ofn = 'TE000'+sn+'_source.csv'
  files = []
  output = ''
  with open (fn) as csvfile:
     csv_reader = csv.reader(csvfile, delimiter=',')
     for row in csv_reader:
        if row[1] not  in files:
          files.append(row[1])
  #Unicode,Image,X,Y,Block ID,Char ID,Width,Height,Overlay
  #U+20086,TE00015_0029_2,0518,0940,B0001,C0001,137,215,0
  output +=  'Image,Manifest URI,Canvas URI,Image Info\n'
  for canvas in files:
      line = canvas+','
      line += 'https://candra.dhii.jp/iiif/rikushotsu/TE000'+sn+'/manifest.json'
      line += ',https://candra.dhii.jp/iiif/rikushotsu/TE000'+sn+'/canvas/'+canvas
      line += ',https://imgsrv.dhii.jp/iiifimgs/rikushotsu/TE000'+sn+'/'+canvas+'.tif/info.json\n'
      output += line
  with open (ofn, mode='w') as f:
    f.write(output)

